Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 7309)
@@ -286,24 +353,23 @@
             at_i(:,:) = at_i(:,:) + a_i(:,:,jl)
          END DO
-
-         !------------------------------------------------------------------------------!
-         ! Diffusion of Ice fields                  
-         !------------------------------------------------------------------------------!
-         !------------------------------------
-         !  Diffusion of other ice variables
-         !------------------------------------
+         
+         CALL wrk_dealloc( jpi,jpj,            zarea )
+         CALL wrk_dealloc( jpi,jpj,1,          z0opw )
+         CALL wrk_dealloc( jpi,jpj,jpl,        z0ice, z0snw, z0ai, z0es , z0smi , z0oi )
+         CALL wrk_dealloc( jpi,jpj,nlay_i,jpl, z0ei )
+
+      END SELECT
+      
+      !------------------------------!
+      ! Diffusion of Ice fields                  
+      !------------------------------!
+      IF( nn_ahi0 /= -1 .AND. nn_limdyn == 2 ) THEN
+         !
+         ! --- Prepare diffusion for variables with categories --- !
+         !     mask eddy diffusivity coefficient at ocean U- and V-points
          jm=1
          DO jl = 1, jpl
-         !                             ! Masked eddy diffusivity coefficient at ocean U- and V-points
-         !   DO jj = 1, jpjm1                 ! NB: has not to be defined on jpj line and jpi row
-         !      DO ji = 1 , fs_jpim1   ! vector opt.
-         !         pahu(ji,jj) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -a_i(ji  ,jj,jl) ) ) )   &
-         !            &        * ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -a_i(ji+1,jj,jl) ) ) ) * ahiu(ji,jj)
-         !         pahv(ji,jj) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -a_i(ji,jj  ,jl) ) ) )   &
-         !            &        * ( 1._wp - MAX( 0._wp, SIGN( 1._wp,- a_i(ji,jj+1,jl) ) ) ) * ahiv(ji,jj)
-         !      END DO
-         !   END DO
             DO jj = 1, jpjm1                 ! NB: has not to be defined on jpj line and jpi row
-               DO ji = 1 , fs_jpim1   ! vector opt.
+               DO ji = 1 , fs_jpim1
                   pahu3D(ji,jj,jl) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -a_i(ji  ,jj,  jl ) ) ) )   &
                   &                * ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -a_i(ji+1,jj,  jl ) ) ) ) * ahiu(ji,jj)
@@ -313,36 +379,22 @@
             END DO
 
-            zhdfptab(:,:,jm)= a_i  (:,:,  jl); jm = jm + 1    
+            zhdfptab(:,:,jm)= a_i  (:,:,  jl); jm = jm + 1
             zhdfptab(:,:,jm)= v_i  (:,:,  jl); jm = jm + 1
-            zhdfptab(:,:,jm)= v_s  (:,:,  jl); jm = jm + 1 
+            zhdfptab(:,:,jm)= v_s  (:,:,  jl); jm = jm + 1
             zhdfptab(:,:,jm)= smv_i(:,:,  jl); jm = jm + 1
             zhdfptab(:,:,jm)= oa_i (:,:,  jl); jm = jm + 1
             zhdfptab(:,:,jm)= e_s  (:,:,1,jl); jm = jm + 1
-         ! Sample of adding more variables to apply lim_hdf using lim_hdf optimization---
-         !   zhdfptab(:,:,jm) = variable_1 (:,:,1,jl); jm = jm + 1  
-         !   zhdfptab(:,:,jm) = variable_2 (:,:,1,jl); jm = jm + 1 
-         !
-         ! and in this example the parameter ihdf_vars musb be changed to 8 (necessary for allocation)
-         !----------------------------------------------------------------------------------------
+            ! Sample of adding more variables to apply lim_hdf (ihdf_vars must be increased)
+            !   zhdfptab(:,:,jm) = variable_1 (:,:,1,jl); jm = jm + 1  
+            !   zhdfptab(:,:,jm) = variable_2 (:,:,1,jl); jm = jm + 1 
             DO jk = 1, nlay_i
               zhdfptab(:,:,jm)=e_i(:,:,jk,jl); jm= jm+1
             END DO
          END DO
-         !
-         !--------------------------------
-         !  diffusion of open water area
-         !--------------------------------
-         !                             ! Masked eddy diffusivity coefficient at ocean U- and V-points
-         !DO jj = 1, jpjm1                    ! NB: has not to be defined on jpj line and jpi row
-         !   DO ji = 1 , fs_jpim1   ! vector opt.
-         !      pahu(ji,jj) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -at_i(ji  ,jj) ) ) )   &
-         !         &        * ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -at_i(ji+1,jj) ) ) ) * ahiu(ji,jj)
-         !      pahv(ji,jj) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -at_i(ji,jj  ) ) ) )   &
-         !         &        * ( 1._wp - MAX( 0._wp, SIGN( 1._wp,- at_i(ji,jj+1) ) ) ) * ahiv(ji,jj)
-         !   END DO
-         !END DO
-         
+
+         ! --- Prepare diffusion for open water area --- !
+         !     mask eddy diffusivity coefficient at ocean U- and V-points
          DO jj = 1, jpjm1                    ! NB: has not to be defined on jpj line and jpi row
-            DO ji = 1 , fs_jpim1   ! vector opt.
+            DO ji = 1 , fs_jpim1
                pahu3D(ji,jj,jpl+1) = ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -at_i(ji  ,jj) ) ) )   &
                   &                * ( 1._wp - MAX( 0._wp, SIGN( 1._wp, -at_i(ji+1,jj) ) ) ) * ahiu(ji,jj)
@@ -353,91 +405,63 @@
          !
          zhdfptab(:,:,jm)= ato_i  (:,:);
-         CALL lim_hdf( zhdfptab, ihdf_vars, jpl, nlay_i) 
-
+
+         ! --- Apply diffusion --- !
+         CALL lim_hdf( zhdfptab, ihdf_vars )
+
+         ! --- Recover properties --- !
          jm=1
          DO jl = 1, jpl
-            a_i  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1      
-            v_i  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1 
-            v_s  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1 
-            smv_i(:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1 
-            oa_i (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1 
-            e_s  (:,:,1,jl) = zhdfptab(:,:,jm); jm = jm + 1 
-         ! Sample of adding more variables to apply lim_hdf---------
-         !   variable_1  (:,:,1,jl) = zhdfptab(:,:, jm  ) ; jm + 1 
-         !   variable_2  (:,:,1,jl) = zhdfptab(:,:, jm  ) ; jm + 1
-         !-----------------------------------------------------------
+            a_i  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1
+            v_i  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1
+            v_s  (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1
+            smv_i(:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1
+            oa_i (:,:,  jl) = zhdfptab(:,:,jm); jm = jm + 1
+            e_s  (:,:,1,jl) = zhdfptab(:,:,jm); jm = jm + 1
+            ! Sample of adding more variables to apply lim_hdf
+            !   variable_1  (:,:,1,jl) = zhdfptab(:,:, jm  ) ; jm + 1 
+            !   variable_2  (:,:,1,jl) = zhdfptab(:,:, jm  ) ; jm + 1
             DO jk = 1, nlay_i
-               e_i(:,:,jk,jl) = zhdfptab(:,:,jm);jm= jm + 1 
-            END DO
-         END DO
-
+               e_i(:,:,jk,jl) = zhdfptab(:,:,jm);jm= jm + 1
+            END DO
+         END DO
          ato_i  (:,:) = zhdfptab(:,:,jm)
-
-         !------------------------------------------------------------------------------!
-         ! limit ice properties after transport                           
-         !------------------------------------------------------------------------------!
-!!gm & cr   :  MAX should not be active if adv scheme is positive !
+              
+      ENDIF
+
+      ! --- diags ---
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            diag_trp_ei (ji,jj) = ( SUM( e_i  (ji,jj,1:nlay_i,:) ) -  zeiold(ji,jj) ) * r1_rdtice
+            diag_trp_es (ji,jj) = ( SUM( e_s  (ji,jj,1:nlay_s,:) ) -  zesold(ji,jj) ) * r1_rdtice
+            diag_trp_smv(ji,jj) = ( SUM( smv_i(ji,jj,:)          ) - zsmvold(ji,jj) ) * r1_rdtice
+            diag_trp_vi (ji,jj) =   SUM(   v_i(ji,jj,:)            -  zviold(ji,jj,:) ) * r1_rdtice
+            diag_trp_vs (ji,jj) =   SUM(   v_s(ji,jj,:)            -  zvsold(ji,jj,:) ) * r1_rdtice
+         END DO
+      END DO
+      
+      IF( nn_limdyn == 2) THEN
+
+         ! zap small areas
+         CALL lim_var_zapsmall
+           
+         !--- Thickness correction in case too high --- !
          DO jl = 1, jpl
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  v_s  (ji,jj,jl)   = MAX( 0._wp, v_s  (ji,jj,jl) )
-                  v_i  (ji,jj,jl)   = MAX( 0._wp, v_i  (ji,jj,jl) )
-                  smv_i(ji,jj,jl)   = MAX( 0._wp, smv_i(ji,jj,jl) )
-                  oa_i (ji,jj,jl)   = MAX( 0._wp, oa_i (ji,jj,jl) )
-                  a_i  (ji,jj,jl)   = MAX( 0._wp, a_i  (ji,jj,jl) )
-                  e_s  (ji,jj,1,jl) = MAX( 0._wp, e_s  (ji,jj,1,jl) )
-               END DO
-            END DO
-
-            DO jk = 1, nlay_i
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     e_i(ji,jj,jk,jl) = MAX( 0._wp, e_i(ji,jj,jk,jl) )
-                  END DO
-               END DO
-            END DO
-         END DO
-!!gm & cr 
-
-         ! --- diags ---
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               diag_trp_ei(ji,jj) = ( SUM( e_i(ji,jj,1:nlay_i,:) ) - zeiold(ji,jj) ) * r1_rdtice
-               diag_trp_es(ji,jj) = ( SUM( e_s(ji,jj,1:nlay_s,:) ) - zesold(ji,jj) ) * r1_rdtice
-
-               diag_trp_vi (ji,jj) = SUM(   v_i(ji,jj,:) -  zviold(ji,jj,:) ) * r1_rdtice
-               diag_trp_vs (ji,jj) = SUM(   v_s(ji,jj,:) -  zvsold(ji,jj,:) ) * r1_rdtice
-               diag_trp_smv(ji,jj) = SUM( smv_i(ji,jj,:) - zsmvold(ji,jj,:) ) * r1_rdtice
-            END DO
-         END DO
-
-         ! zap small areas
-         CALL lim_var_zapsmall
-
-         !--- Thickness correction in case too high --------------------------------------------------------
-         DO jl = 1, jpl
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-
+                  
                   IF ( v_i(ji,jj,jl) > 0._wp ) THEN
-
+                     
                      rswitch          = MAX( 0._wp , SIGN( 1._wp, a_i(ji,jj,jl) - epsi20 ) )
                      ht_i  (ji,jj,jl) = v_i (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi20 ) * rswitch
                      ht_s  (ji,jj,jl) = v_s (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi20 ) * rswitch
                      
-                     zvi  = v_i  (ji,jj,jl)
-                     zvs  = v_s  (ji,jj,jl)
-                     zsmv = smv_i(ji,jj,jl)
-                     zes  = e_s  (ji,jj,1,jl)
-                     zei  = SUM( e_i(ji,jj,1:nlay_i,jl) )
-
                      zdv  = v_i(ji,jj,jl) + v_s(ji,jj,jl) - zviold(ji,jj,jl) - zvsold(ji,jj,jl)  
-
+                     
                      IF ( ( zdv >  0.0 .AND. (ht_i(ji,jj,jl)+ht_s(ji,jj,jl)) > zhimax(ji,jj,jl) .AND. zatold(ji,jj) < 0.80 ) .OR. &
                         & ( zdv <= 0.0 .AND. (ht_i(ji,jj,jl)+ht_s(ji,jj,jl)) > zhimax(ji,jj,jl) ) ) THEN
-
+                        
                         rswitch        = MAX( 0._wp, SIGN( 1._wp, zhimax(ji,jj,jl) - epsi20 ) )
                         a_i(ji,jj,jl)  = rswitch * ( v_i(ji,jj,jl) + v_s(ji,jj,jl) ) / MAX( zhimax(ji,jj,jl), epsi20 )
-
+                        
                         ! small correction due to *rswitch for a_i
                         v_i  (ji,jj,jl)        = rswitch * v_i  (ji,jj,jl)
@@ -446,16 +470,9 @@
                         e_s(ji,jj,1,jl)        = rswitch * e_s(ji,jj,1,jl)
                         e_i(ji,jj,1:nlay_i,jl) = rswitch * e_i(ji,jj,1:nlay_i,jl)
-
-                        ! Update mass fluxes
-                        wfx_res(ji,jj) = wfx_res(ji,jj) - ( v_i(ji,jj,jl) - zvi ) * rhoic * r1_rdtice
-                        wfx_snw(ji,jj) = wfx_snw(ji,jj) - ( v_s(ji,jj,jl) - zvs ) * rhosn * r1_rdtice
-                        sfx_res(ji,jj) = sfx_res(ji,jj) - ( smv_i(ji,jj,jl) - zsmv ) * rhoic * r1_rdtice 
-                        hfx_res(ji,jj) = hfx_res(ji,jj) + ( e_s(ji,jj,1,jl) - zes ) * r1_rdtice ! W.m-2 <0
-                        hfx_res(ji,jj) = hfx_res(ji,jj) + ( SUM( e_i(ji,jj,1:nlay_i,jl) ) - zei ) * r1_rdtice ! W.m-2 <0
-
+                                                
                      ENDIF
-
+                     
                   ENDIF
-
+                
                END DO
             END DO
@@ -463,57 +480,55 @@
          ! -------------------------------------------------
          
-         !--------------------------------------
-         ! Impose a_i < amax in mono-category
-         !--------------------------------------
-         !
-         IF ( ( nn_monocat == 2 ) .AND. ( jpl == 1 ) ) THEN ! simple conservative piling, comparable with LIM2
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  a_i(ji,jj,1)  = MIN( a_i(ji,jj,1), rn_amax_2d(ji,jj) )
-               END DO
-            END DO
-         ENDIF
-
-         ! --- agglomerate variables -----------------
-         vt_i (:,:) = 0._wp
-         vt_s (:,:) = 0._wp
-         at_i (:,:) = 0._wp
+         ! Force the upper limit of ht_i to always be < hi_max (99 m).
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               rswitch         = MAX( 0._wp , SIGN( 1._wp, ht_i(ji,jj,jpl) - epsi20 ) )
+               ht_i(ji,jj,jpl) = MIN( ht_i(ji,jj,jpl) , hi_max(jpl) )
+               a_i (ji,jj,jpl) = v_i(ji,jj,jpl) / MAX( ht_i(ji,jj,jpl) , epsi20 ) * rswitch
+            END DO
+         END DO
+
+      ENDIF
+         
+      !------------------------------------------------------------
+      ! Impose a_i < amax if no ridging/rafting or in mono-category
+      !------------------------------------------------------------
+      !
+      at_i(:,:) = SUM( a_i(:,:,:), dim=3 )
+      IF ( nn_limdyn == 1 .OR. ( ( nn_monocat == 2 ) .AND. ( jpl == 1 ) ) ) THEN ! simple conservative piling, comparable with LIM2
          DO jl = 1, jpl
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  vt_i(ji,jj) = vt_i(ji,jj) + v_i(ji,jj,jl)
-                  vt_s(ji,jj) = vt_s(ji,jj) + v_s(ji,jj,jl)
-                  at_i(ji,jj) = at_i(ji,jj) + a_i(ji,jj,jl)
+                  rswitch       = MAX( 0._wp, SIGN( 1._wp, at_i(ji,jj) - epsi20 ) )
+                  zda           = rswitch * MIN( rn_amax_2d(ji,jj) - at_i(ji,jj), 0._wp )  &
+                     &                    * a_i(ji,jj,jl) / MAX( at_i(ji,jj), epsi20 )
+                  a_i(ji,jj,jl) = a_i(ji,jj,jl) + zda
                END DO
             END DO
          END DO
-
-         ! --- open water = 1 if at_i=0 --------------------------------
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               rswitch      = MAX( 0._wp , SIGN( 1._wp, - at_i(ji,jj) ) )
-               ato_i(ji,jj) = rswitch + (1._wp - rswitch ) * ato_i(ji,jj)
-            END DO
-         END DO      
-
-         ! conservation test
-         IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limtrp', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
       ENDIF
-
+      
+      ! --- agglomerate variables -----------------
+      vt_i(:,:) = SUM( v_i(:,:,:), dim=3 )
+      vt_s(:,:) = SUM( v_s(:,:,:), dim=3 )
+      at_i(:,:) = SUM( a_i(:,:,:), dim=3 )
+      
+      ! --- open water = 1 if at_i=0 --------------------------------
+      WHERE( at_i == 0._wp ) ato_i = 1._wp 
+      
+      ! conservation test
+      IF( ln_limdiachk )   CALL lim_cons_hsm(1, 'limtrp', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+        
       ! -------------------------------------------------
       ! control prints
       ! -------------------------------------------------
-      IF( ln_icectl )   CALL lim_prt( kt, iiceprt, jiceprt,-1, ' - ice dyn & trp - ' )
+      IF( ln_limctl )   CALL lim_prt( kt, iiceprt, jiceprt,-1, ' - ice dyn & trp - ' )
       !
-      CALL wrk_dealloc( jpi,jpj,            zsm, zatold, zeiold, zesold )
-      CALL wrk_dealloc( jpi,jpj,jpl,        z0ice, z0snw, z0ai, z0es , z0smi , z0oi )
-      CALL wrk_dealloc( jpi,jpj,1,          z0opw )
-      CALL wrk_dealloc( jpi,jpj,nlay_i,jpl, z0ei )
-      CALL wrk_dealloc( jpi,jpj,jpl,        zviold, zvsold, zhimax, zsmvold )
-      CALL wrk_dealloc( jpi,jpj,jpl*(ihdf_vars+nlay_i)+1,zhdfptab)
+      CALL wrk_dealloc( jpi,jpj,                            zatold, zeiold, zesold, zsmvold )
+      CALL wrk_dealloc( jpi,jpj,jpl,                        zhimax, zviold, zvsold )
+      CALL wrk_dealloc( jpi,jpj,jpl*(ihdf_vars + nlay_i)+1, zhdfptab)
       !
       IF( nn_timing == 1 )  CALL timing_stop('limtrp')
-
+      !
    END SUBROUTINE lim_trp
 
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 7309)
@@ -15,5 +15,4 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
    USE sbc_ice         ! Surface boundary condition: ice fields
-   USE dom_ice
    USE dom_oce
    USE phycst          ! physical constants
@@ -22,8 +21,8 @@
    USE limitd_th
    USE limvar
-   USE prtctl          ! Print control
    USE wrk_nemo        ! work arrays
    USE timing          ! Timing
    USE limcons         ! conservation tests
+   USE limctl          ! control prints
    USE lib_mpp         ! MPP library
    USE lib_fortran     ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
@@ -59,13 +58,12 @@
       IF( nn_timing == 1 )  CALL timing_start('limupdate1')
 
-      IF( ln_limdyn ) THEN 
-
       IF( kt == nit000 .AND. lwp ) THEN
-         WRITE(numout,*) ' lim_update1 ' 
-         WRITE(numout,*) ' ~~~~~~~~~~~ '
+         WRITE(numout,*)'' 
+         WRITE(numout,*)' lim_update1 ' 
+         WRITE(numout,*)' ~~~~~~~~~~~ '
       ENDIF
 
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limupdate1', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limupdate1', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       !----------------------------------------------------
@@ -137,71 +135,13 @@
 
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limupdate1', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limupdate1', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
-      ! -------------------------------------------------
       ! control prints
-      ! -------------------------------------------------
-      IF(ln_ctl) THEN   ! Control print
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=e1e2t      , clinfo1=' lim_update1  : cell area   :')
-         CALL prt_ctl(tab2d_1=at_i       , clinfo1=' lim_update1  : at_i        :')
-         CALL prt_ctl(tab2d_1=vt_i       , clinfo1=' lim_update1  : vt_i        :')
-         CALL prt_ctl(tab2d_1=vt_s       , clinfo1=' lim_update1  : vt_s        :')
-         CALL prt_ctl(tab2d_1=strength   , clinfo1=' lim_update1  : strength    :')
-         CALL prt_ctl(tab2d_1=u_ice      , clinfo1=' lim_update1  : u_ice       :', tab2d_2=v_ice      , clinfo2=' v_ice       :')
-         CALL prt_ctl(tab2d_1=u_ice_b    , clinfo1=' lim_update1  : u_ice_b     :', tab2d_2=v_ice_b    , clinfo2=' v_ice_b     :')
+      IF( ln_ctl )       CALL lim_prt3D( 'limupdate1' )
+   
+      IF( nn_timing == 1 )  CALL timing_stop('limupdate1')
 
-         DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=ht_i       (:,:,jl)        , clinfo1= ' lim_update1  : ht_i        : ')
-            CALL prt_ctl(tab2d_1=ht_s       (:,:,jl)        , clinfo1= ' lim_update1  : ht_s        : ')
-            CALL prt_ctl(tab2d_1=t_su       (:,:,jl)        , clinfo1= ' lim_update1  : t_su        : ')
-            CALL prt_ctl(tab2d_1=t_s        (:,:,1,jl)      , clinfo1= ' lim_update1  : t_snow      : ')
-            CALL prt_ctl(tab2d_1=sm_i       (:,:,jl)        , clinfo1= ' lim_update1  : sm_i        : ')
-            CALL prt_ctl(tab2d_1=o_i        (:,:,jl)        , clinfo1= ' lim_update1  : o_i         : ')
-            CALL prt_ctl(tab2d_1=a_i        (:,:,jl)        , clinfo1= ' lim_update1  : a_i         : ')
-            CALL prt_ctl(tab2d_1=a_i_b      (:,:,jl)        , clinfo1= ' lim_update1  : a_i_b       : ')
-            CALL prt_ctl(tab2d_1=v_i        (:,:,jl)        , clinfo1= ' lim_update1  : v_i         : ')
-            CALL prt_ctl(tab2d_1=v_i_b      (:,:,jl)        , clinfo1= ' lim_update1  : v_i_b       : ')
-            CALL prt_ctl(tab2d_1=v_s        (:,:,jl)        , clinfo1= ' lim_update1  : v_s         : ')
-            CALL prt_ctl(tab2d_1=v_s_b      (:,:,jl)        , clinfo1= ' lim_update1  : v_s_b       : ')
-            CALL prt_ctl(tab2d_1=e_i        (:,:,1,jl)      , clinfo1= ' lim_update1  : e_i1        : ')
-            CALL prt_ctl(tab2d_1=e_i_b      (:,:,1,jl)      , clinfo1= ' lim_update1  : e_i1_b      : ')
-            CALL prt_ctl(tab2d_1=e_i        (:,:,2,jl)      , clinfo1= ' lim_update1  : e_i2        : ')
-            CALL prt_ctl(tab2d_1=e_i_b      (:,:,2,jl)      , clinfo1= ' lim_update1  : e_i2_b      : ')
-            CALL prt_ctl(tab2d_1=e_s        (:,:,1,jl)      , clinfo1= ' lim_update1  : e_snow      : ')
-            CALL prt_ctl(tab2d_1=e_s_b      (:,:,1,jl)      , clinfo1= ' lim_update1  : e_snow_b    : ')
-            CALL prt_ctl(tab2d_1=smv_i      (:,:,jl)        , clinfo1= ' lim_update1  : smv_i       : ')
-            CALL prt_ctl(tab2d_1=smv_i_b    (:,:,jl)        , clinfo1= ' lim_update1  : smv_i_b     : ')
-            CALL prt_ctl(tab2d_1=oa_i       (:,:,jl)        , clinfo1= ' lim_update1  : oa_i        : ')
-            CALL prt_ctl(tab2d_1=oa_i_b     (:,:,jl)        , clinfo1= ' lim_update1  : oa_i_b      : ')
+   END SUBROUTINE lim_update1
 
-            DO jk = 1, nlay_i
-               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
-               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_update1  : t_i       : ')
-            END DO
-         END DO
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Heat / FW fluxes : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=sst_m  , clinfo1= ' lim_update1 : sst   : ', tab2d_2=sss_m     , clinfo2= ' sss       : ')
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Stresses : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=utau       , clinfo1= ' lim_update1 : utau      : ', tab2d_2=vtau       , clinfo2= ' vtau      : ')
-         CALL prt_ctl(tab2d_1=utau_ice   , clinfo1= ' lim_update1 : utau_ice  : ', tab2d_2=vtau_ice   , clinfo2= ' vtau_ice  : ')
-         CALL prt_ctl(tab2d_1=u_oce      , clinfo1= ' lim_update1 : u_oce     : ', tab2d_2=v_oce      , clinfo2= ' v_oce     : ')
-      ENDIF
-   
-      ENDIF ! ln_limdyn
-
-      IF( nn_timing == 1 )  CALL timing_stop('limupdate1')
-   END SUBROUTINE lim_update1
 #else
    !!----------------------------------------------------------------------
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 7309)
@@ -15,5 +15,4 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
    USE sbc_ice         ! Surface boundary condition: ice fields
-   USE dom_ice
    USE dom_oce
    USE phycst          ! physical constants
@@ -22,5 +21,4 @@
    USE limitd_th
    USE limvar
-   USE prtctl          ! Print control
    USE lbclnk          ! lateral boundary condition - MPP exchanges
    USE wrk_nemo        ! work arrays
@@ -62,10 +60,11 @@
 
       IF( kt == nit000 .AND. lwp ) THEN
-         WRITE(numout,*) ' lim_update2 '
-         WRITE(numout,*) ' ~~~~~~~~~~~ '
+         WRITE(numout,*)''
+         WRITE(numout,*)' lim_update2 '
+         WRITE(numout,*)' ~~~~~~~~~~~ '
       ENDIF
 
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limupdate2', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limupdate2', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       !----------------------------------------------------------------------
@@ -176,76 +175,14 @@
 
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limupdate2', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limupdate2', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
-      ! necessary calls (at least for coupling)
-      CALL lim_var_glo2eqv
-      CALL lim_var_agg(2)
-
-      ! -------------------------------------------------
       ! control prints
-      ! -------------------------------------------------
-      IF( ln_icectl )   CALL lim_prt( kt, iiceprt, jiceprt, 2, ' - Final state - ' )   ! control print
-
-      IF(ln_ctl) THEN   ! Control print
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=e1e2t      , clinfo1=' lim_update2  : cell area   :')
-         CALL prt_ctl(tab2d_1=at_i       , clinfo1=' lim_update2  : at_i        :')
-         CALL prt_ctl(tab2d_1=vt_i       , clinfo1=' lim_update2  : vt_i        :')
-         CALL prt_ctl(tab2d_1=vt_s       , clinfo1=' lim_update2  : vt_s        :')
-         CALL prt_ctl(tab2d_1=strength   , clinfo1=' lim_update2  : strength    :')
-         CALL prt_ctl(tab2d_1=u_ice      , clinfo1=' lim_update2  : u_ice       :', tab2d_2=v_ice      , clinfo2=' v_ice       :')
-         CALL prt_ctl(tab2d_1=u_ice_b    , clinfo1=' lim_update2  : u_ice_b     :', tab2d_2=v_ice_b    , clinfo2=' v_ice_b     :')
-
-         DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=ht_i       (:,:,jl)        , clinfo1= ' lim_update2  : ht_i        : ')
-            CALL prt_ctl(tab2d_1=ht_s       (:,:,jl)        , clinfo1= ' lim_update2  : ht_s        : ')
-            CALL prt_ctl(tab2d_1=t_su       (:,:,jl)        , clinfo1= ' lim_update2  : t_su        : ')
-            CALL prt_ctl(tab2d_1=t_s        (:,:,1,jl)      , clinfo1= ' lim_update2  : t_snow      : ')
-            CALL prt_ctl(tab2d_1=sm_i       (:,:,jl)        , clinfo1= ' lim_update2  : sm_i        : ')
-            CALL prt_ctl(tab2d_1=o_i        (:,:,jl)        , clinfo1= ' lim_update2  : o_i         : ')
-            CALL prt_ctl(tab2d_1=a_i        (:,:,jl)        , clinfo1= ' lim_update2  : a_i         : ')
-            CALL prt_ctl(tab2d_1=a_i_b      (:,:,jl)        , clinfo1= ' lim_update2  : a_i_b       : ')
-            CALL prt_ctl(tab2d_1=v_i        (:,:,jl)        , clinfo1= ' lim_update2  : v_i         : ')
-            CALL prt_ctl(tab2d_1=v_i_b      (:,:,jl)        , clinfo1= ' lim_update2  : v_i_b       : ')
-            CALL prt_ctl(tab2d_1=v_s        (:,:,jl)        , clinfo1= ' lim_update2  : v_s         : ')
-            CALL prt_ctl(tab2d_1=v_s_b      (:,:,jl)        , clinfo1= ' lim_update2  : v_s_b       : ')
-            CALL prt_ctl(tab2d_1=e_i        (:,:,1,jl)      , clinfo1= ' lim_update2  : e_i1        : ')
-            CALL prt_ctl(tab2d_1=e_i_b      (:,:,1,jl)      , clinfo1= ' lim_update2  : e_i1_b      : ')
-            CALL prt_ctl(tab2d_1=e_i        (:,:,2,jl)      , clinfo1= ' lim_update2  : e_i2        : ')
-            CALL prt_ctl(tab2d_1=e_i_b      (:,:,2,jl)      , clinfo1= ' lim_update2  : e_i2_b      : ')
-            CALL prt_ctl(tab2d_1=e_s        (:,:,1,jl)      , clinfo1= ' lim_update2  : e_snow      : ')
-            CALL prt_ctl(tab2d_1=e_s_b      (:,:,1,jl)      , clinfo1= ' lim_update2  : e_snow_b    : ')
-            CALL prt_ctl(tab2d_1=smv_i      (:,:,jl)        , clinfo1= ' lim_update2  : smv_i       : ')
-            CALL prt_ctl(tab2d_1=smv_i_b    (:,:,jl)        , clinfo1= ' lim_update2  : smv_i_b     : ')
-            CALL prt_ctl(tab2d_1=oa_i       (:,:,jl)        , clinfo1= ' lim_update2  : oa_i        : ')
-            CALL prt_ctl(tab2d_1=oa_i_b     (:,:,jl)        , clinfo1= ' lim_update2  : oa_i_b      : ')
-
-            DO jk = 1, nlay_i
-               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
-               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_update2  : t_i       : ')
-            END DO
-         END DO
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Heat / FW fluxes : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=sst_m  , clinfo1= ' lim_update2 : sst   : ', tab2d_2=sss_m     , clinfo2= ' sss       : ')
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Stresses : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=utau       , clinfo1= ' lim_update2 : utau      : ', tab2d_2=vtau       , clinfo2= ' vtau      : ')
-         CALL prt_ctl(tab2d_1=utau_ice   , clinfo1= ' lim_update2 : utau_ice  : ', tab2d_2=vtau_ice   , clinfo2= ' vtau_ice  : ')
-         CALL prt_ctl(tab2d_1=u_oce      , clinfo1= ' lim_update2 : u_oce     : ', tab2d_2=v_oce      , clinfo2= ' v_oce     : ')
-      ENDIF
+      IF( ln_limctl )    CALL lim_prt( kt, iiceprt, jiceprt, 2, ' - Final state - ' )
+      IF( ln_ctl )       CALL lim_prt3D( 'limupdate2' )
    
       IF( nn_timing == 1 )  CALL timing_stop('limupdate2')
 
    END SUBROUTINE lim_update2
+
 #else
    !!----------------------------------------------------------------------
